
////////////////////////////////////////////////////////////////////////////
//	Copyright : Amit Dey 2003
//
//	Email :visualcdev@hotmail.com
//
//	This code may be used in compiled form in any way you desire. This
//	file may be redistributed unmodified by any means PROVIDING it is 
//	not sold for profit without the authors written consent, and 
//	providing that this notice and the authors name is included.
//
//	This file is provided 'as is' with no expressed or implied warranty.
//	The author accepts no liability if it causes any damage to your computer.
//
//	Do expect bugs.
//	Please let me know of any bugs/mods/improvements.
//	and I will try to fix/incorporate them into this file.
//	Enjoy!
//
//	Description : Universal Word Addin
////////////////////////////////////////////////////////////////////////////
// Addin.h : Declaration of the CAddin

#ifndef __ADDIN_H_
#define __ADDIN_H_
#include "stdafx.h"

#include "resource.h"       // main symbols

#import "C:\Program Files\Microsoft Office\Office\MSWORD8.olb" rename_namespace("MSWORD"), rename("ExitWindows","WordExitWindows"), named_guids, raw_interfaces_only
using namespace MSWORD;


//#import "D:\Program Files\Microsoft Office\Office\MSWORD9.olb" //rename_namespace("MSWORD"), rename("ExitWindows","WordExitWindows"), //named_guids, raw_interfaces_only
//using namespace MSWORD;


/////////////////////////////////////////////////////////////////////////////
// CAddin
class ATL_NO_VTABLE CAddin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAddin, &CLSID_Addin>,
	public ISupportErrorInfo,
	public IDispatchImpl<IAddin, &IID_IAddin, &LIBID_UNIVERSALADDINLib>
{
public:
	CAddin()
	{
		m_spApp = NULL;
		m_spButton = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAddin)
	COM_INTERFACE_ENTRY(IAddin)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAddin
public:
	STDMETHOD(ClickItem1)();
	STDMETHOD(Uninit)(/*[in]*/ IDispatch* pDisp);
	STDMETHOD(Init)(/*[in]*/ IDispatch* pDisp);
private:
		CComPtr <MSWORD::_Application> m_spApp; 
};

#endif //__ADDIN_H_
